#if !defined(MAINFRM_H_INCLUDED_)
#define MAINFRM_H_INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

class CMainFrame : public CMDIFrameWnd
{
	DECLARE_DYNAMIC(CMainFrame)
public:
	CMainFrame();
	virtual ~CMainFrame();

	void makeDropdown(u32 cmd);
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
	virtual BOOL OnNotify(WPARAM wParam, LPARAM lParam, LRESULT* pResult);

#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

	int squareFromMode( int sq ) const;
	void UpdateAllViews();

protected:  // control bar embedded members
	CStatusBar  m_wndStatusBar;
	CToolBar    m_wndToolBar;
	CToolBar    m_wndToolBinary;
	CToolBar    m_wndToolUnary;

	enum e_mappingmodes {e_lerf, e_berf, e_lefr, e_befr, e_lerbef, e_berlef, e_lefber, e_befler} m_mapping_mode;

protected:
	afx_msg int OnCreate(LPCREATESTRUCT lpCreateStruct);
	afx_msg void OnDestroy();
	afx_msg void OnChooseConstant();
	afx_msg void OnLERF();
	afx_msg void OnBERF();
	afx_msg void OnLEFR();
	afx_msg void OnBEFR();
	afx_msg void OnLERBEF();
	afx_msg void OnBERLEF();
	afx_msg void OnLEFBER();
	afx_msg void OnBEFLER();
	afx_msg void OnUpdateLERF(CCmdUI* pCmdUI);
	afx_msg void OnUpdateBERF(CCmdUI* pCmdUI);
	afx_msg void OnUpdateLEFR(CCmdUI* pCmdUI);
	afx_msg void OnUpdateBEFR(CCmdUI* pCmdUI);
	afx_msg void OnUpdateLERBEF(CCmdUI* pCmdUI);
	afx_msg void OnUpdateBERLEF(CCmdUI* pCmdUI);
	afx_msg void OnUpdateLEFBER(CCmdUI* pCmdUI);
	afx_msg void OnUpdateBEFLER(CCmdUI* pCmdUI);
	DECLARE_MESSAGE_MAP()
};

#endif
