#if !defined(BBSTUFF_H_INCLUDED_)
#define BBSTUFF_H_INCLUDED_

union union64 {u64 bb; double dbl;};

enum 
{
	DONT_KNOW,
	IS_HEX,
	IS_DEC,
	IS_DBL,
	IS_FEN
};

enum 
{
	DBL,
	I64,
	I32,
	I16,
	I8
};

extern bool isFen(const CString &s);
extern u64 hexdecfenBB(const CString &str, u32 piecemask, int calcmode, int &kind);
extern void bb2hexStr(u64 bb, CString &hex);
extern void bb2decStr(u64 bb, CString &dec);
extern void bb2BoardStr(u64 bb, CString &str);

extern u64 mulh(u64 bb1, u64 bb2);
extern u32 popCount(u64 bb);
extern u64 add32(u64 a, u64 b);
extern u64 add16(u64 a, u64 b);
extern u64 add8(u64 a, u64 b);
extern u64 sub32(u64 a, u64 b);
extern u64 sub16(u64 a, u64 b);
extern u64 sub8(u64 a, u64 b);

extern u64 flip(u64 bb);
extern u64 mirror(u64 bb);
extern u64 diaflip(u64 bb);
extern u64 antflip(u64 bb);

#endif
