#if !defined(BIBOB_DOC_INCLUDED_)
#define BIBOB_DOC_INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000


class CBibobDoc : public CDocument
{
protected: // create from serialization only
	CBibobDoc();
	DECLARE_DYNCREATE(CBibobDoc)

public:
	u64  getBitBoard() const {return m_BitBoard;}
	void getBitBoardAsHexString(CString &hex) const;
	void getBitBoardAsBoardString(CString &str) const;
	void getBitBoardAsDecString(CString &dec) const;
	const CString& getFen() {return m_fen;}
	bool hasFen() {return m_fen.GetLength() > 8;}

	CString getDocTitle();
	CString appendTitle(const CString& s);

	void setBitBoard(u64 bb) {m_BitBoard = bb;}
	bool setBitBoardByHexDecFen(const CString &str, u32 piecemask, int calcmode);
	void pasteInternalFen(u32 piecemask, int calcmode);
	void clearFen();
	void StopAuto();

	virtual BOOL OnNewDocument();
	virtual void Serialize(CArchive& ar);

public:
	virtual ~CBibobDoc();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:
	u64	m_BitBoard;
	CString m_fen;

protected:
	afx_msg void OnAutoStop();
	DECLARE_MESSAGE_MAP()
};

#endif // !defined(BIBOB_DOC_INCLUDED_)
